/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: setDateOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the setDateOperationDispatcher. It contains of all the generic methods
    for setDateOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setDateOperationDispatcher_HXX
#define setDateOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setDateOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setDateOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        setDateOperationDispatcher();
        virtual ~setDateOperationDispatcher();
        static OperationDispatcher *constructor();

 void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setDatePreConditions( Teamcenter::BusinessObject* obj, const date_t dateValue, const bool isNull ) const;
    void setDatePreActions( Teamcenter::BusinessObject* obj, const date_t dateValue, const bool isNull ) const;
    void setDateBaseAction( Teamcenter::BusinessObject* obj, const date_t dateValue, const bool isNull ) const;
    void setDatePostActions( Teamcenter::BusinessObject* obj, const date_t dateValue, const bool isNull ) const;

    // Project 011450 changes
    void setDatePreConditions( METHOD_message_t* msgData, const date_t dateValue, const logical isNull ) const;
    void setDatePreActions( METHOD_message_t* msgData, const date_t dateValue, const logical isNull ) const;
    void setDatePostActions( METHOD_message_t* msgData, const date_t dateValue, const logical isNull ) const;
    void setDateBaseAction( METHOD_message_t* msgData, const date_t dateValue, const logical isNull ) const;

    void setDate( Teamcenter::BusinessObject* obj, const date_t dateValue, const bool isNull ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setDateOperationDispatcher_HXX
